# Hackintool
The Swiss army knife of vanilla Hackintoshing

# WARNING!
Hackintool is not an automated patching tool that does all the work for you. Knowledge is required on how to patch before using it. Please read the Intel Framebuffer patching using WhateverGreen guide before you download this tool! I also recommend reading @jaymonkey's An iDiot's Guide To Lilu and its Plug-ins and @CaseySJ's General Framebuffer Patching Guide using Hackintool.

# Mojave, Lilu + WhateverGreen
You cannot use the Clover's KextsToPatch for framebuffer patching in Mojave for Skylake and above

# Framebuffer Dumps
* There are a few ways to dump your framebuffer data (the second two require WhateverGreen + Lilu debug versions) to read in Hackintool:
* Use the Framebuffer->macOS 10.13.6 / Framebuffer->macOS 10.14 menu to create patches without a framebuffer dump
* Use the -igfxdump boot flag to dump IGPU framebuffer kext to /AppleIntelFramebuffer_X_Y (root of your boot drive) and then File->Open menu
* Use the -igfxfbdump boot flag to dump native and patched framebuffer table to ioreg and then File->Import->IOReg Dump menu

# Features
* Supports Sandy Bridge, Ivy Bridge, Haswell, Broadwell, Skylake, Kaby Lake, Coffee Lake, Cannon Lake and Ice Lake generations
* Create All, Connectors or VRAM patches
* Detect Changes for auto patch creation
* Create Clover patches in hex, base64 or Devices/Properties formats
* Displays native GPU and Model identifiers
* Display and edit Memory Info such as Stolen, Framebuffer, VRAM, Cursor etc.
* Roll over some items for additional info (Tooltips)
* Reads "live" data directly from Framebuffer kexts (if available; see Mojave note below)
* File->Open framebuffer file generated by WhateverGreen's -igfxdump boot flag
* File->Export->Clover config.plist / File->Export->Framebuffer.txt file
* Patch audio layout id
* Add USB port limit patch
* Plug and unplug USB2 / USB3 devices and set port connector types then generate a USBPorts.kext
* Advanced patching options (DVMT pre-alloc 32 MB, VRAM 2048 MB, Disable eGPU, Enable HDMI20 (4K), DP -> HDMI, GfxYTile Fix, Reboot Fix, USB port Limit, Spoof Audio Device Id, FB Port Limit, Spoof Gfx Device Id)

# Credits & Contributions
* vit9696 for WhateverGreen (full credits), Lilu (full credits), AppleALC (full credits), original USBPorts.kext and additional help
* vit9696 for IntelFramebuffer.bt with additional work by bcc9, Piker-Alpha and joevt
* daliansky for Intel Core Platform ID and SMBIOS Quick Reference
* Clover Development Team for various technical info
* vandroiy2013 for audio id data from AppleALC
* RehabMan for the all data patching method, ioreg framebuffer dump and other contributions
* EDID injection (Andy Vandijck / Marchrius)
* USB power injection (corpnewt)
* HDA controllers / codec lists by the VoodooHDA project
* System Configs compilation (CaseySJ)
* Clover downloader (Kozlek / JrCs / slice)
* Kext compiler & installer (Sascha Lamprecht / Gengik84 / LAbyOne)
* Atheros & SATA kexts (Sascha Lamprecht)
* DPCIManager (phpdev32 / MuntashirAkon)
* AppleIntelInfo (Pike R. Alpha)
* gfxutil (mcmatrix)
* VDADecoderChecker (Andy Breuhan)
* iMessageDebug (ElNono / mdmwii / flux84 / sugarface / pokenguyen)
* macserial (vit9696 / MacInfoPkg team)
* Model data (everymac.com)
* Translations: French (Matgen84), German (al6042), Korean (zisqo), Russian / Ukrainian (ctich), Chinese (daliansky, Bat.bat, penghubingzhou)
* Sparkle framework by Andy Matuschak
* Icon & UI updates by ultratiem
